<cfscript>

	setting requestTimeout=300;

	param name="URL.test" 	default="";
	param name="URL.x" 		default="20";

	echo("<h2>#Server.lucee.version ?: Server.railo.version#</h2>");


	tests = {

		 "LDEV-988-A" : "i++"
		,"LDEV-988-B" : "++i"
		,"LDEV-988-C" : "i=i+1"
		,"LDEV-988-D" : "Scoped i++"
	};

	URL.test = ucase(URL.test);

	if (!tests.keyExists(URL.test)) {

		keys = tests.keyArray();
		keys.sort("textnocase");

		echo("<p>Please choose a test to run:<br>");
		echo("<style>table td { padding: 0.35em 0.5em; }</style>");
		echo("<table>");
		echo("<tr><td></td><td></td></tr>");

		for (key in keys) {

			echo('<tr><td><a href="#CGI.SCRIPT_NAME#?test=#key#">#key#</a></td><td>#tests[key]#</td></tr>');
		}

		echo("</table>");

		abort;
	}


	echo("<p>started at #now()#");
	flush;

	java = {

		 ManagementFactory : createObject("java", "java.lang.management.ManagementFactory")
		,Thread : createObject("java", "java.lang.Thread")
	}

	threadMxBean = java.ManagementFactory.getThreadMXBean();
	threadId = java.Thread.currentThread().getId();

	tId = [threadId];		// wrap as cfml array
	tId = javaCast("long[]", tId)

	bestOfX = -1;

	numIterations = 10 * 1000 * 1000;

	loop from=1 to=URL.x index="outer" {

		st1 = threadMxBean.getThreadUserTime( tId )[1];


		switch (URL.test) {

			case "LDEV-988-A":
				for (i=0; i<numIterations; i++) {};
				break;

			case "LDEV-988-B":
				for (i=0; i<numIterations; ++i) {};
				break;

			case "LDEV-988-C":
				for (i=0; i<numIterations; i=i+1) {};
				break;

			case "LDEV-988-D":
				for (variables.i=0; variables.i<numIterations; variables.i++) {};
				break;
		}


		st2 = threadMxBean.getThreadUserTime( tId )[1];
		delta = (st2 - st1) / 1000;

		if (outer == 1)
			bestOfX = delta;
		else
			bestOfX = min(bestOfX, delta);

		sleep(1000);

	} // outer loop


	echo("<p>Test #URL.test#:");
	echo("<div style='font-size: 125%; padding: 0.5em; background-color: orange;'>#tests[URL.test]#</div>");
	echo("<p>Best of #URL.x#:");
	echo("<h2><span style='background-color:yellow;'>#numberFormat(bestOfX, ',')#</span> &micro;s</h2>");
	echo("<p>completed at #now()#");

</cfscript>